<?php

namespace Ems\Controllers;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;


use Ems\Services\PessoaService;

class PessoaController {
    protected $pessoaService;

    public function __construct(PessoaService $pessoaService) {
        $this->pessoaService = $pessoaService;
    }

    public function getPessoa(Request\Row $request, Response $response) {
        try {
            $row = $request->getRow();
            if(!array_key_exists('P_DTMESCOMPETENC', $row)){
                list ($dia, $mes, $ano) = explode ('/', date("d/m/Y"));
                $row['P_DTMESCOMPETENC'] = "01/".$mes."/".$ano;;
            }
            $nrVinculo = $row['NRVINCULOM'];
            $dtmescompetenc = $row['P_DTMESCOMPETENC'];

            $pessoa = $this->pessoaService->getPessoa($nrVinculo, $dtmescompetenc);

            $response->addDataSet(new DataSet('getPessoa', $pessoa));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

}
